# Application web/interface web de la plateforme Fodomust

## Qu'est-ce que Fodomust ?
FoDoMust : Fouille de données Multi-Stratégie Multi-Temporelles. C’est une plateforme qui permet d’analyser en détails des
images spatio-temporelles satellitaires. FoDoMust est utile pour les experts
géographes et les géomaticiens.

Le logiciel permet de classifier les pixels d’une image et de faire du clustering. Ces deux
techniques sont régulièrement utilisées dans l’analyse de données en informatique. La
classification de données peut être illustrée par l’association d’étiquettes sur des
données. Les données qui sont identiques reçoivent alors une même étiquette. Tandis
que le clustering est le processus qui permet de regrouper des données qui se
ressemblent.

![Différence entre classification et clustering](./src/assets/images/documentation/img.png "Différence entre classification et clustering")

La plateforme ou le logiciel FoDoMust est un exécutable écrit en Java, intégrant des algorithmes en R et en Python pour l’analyse de données.

Ensuite, pour que les outils proposés par FoDoMust soient à la portée des experts, il faut rendre les fonctionnalités du logiciel accessibles par un navigateur web. C'est pourquoi, une application web de FoDoMust a été réalisée.

## Application web Fodomust
L'interface web Fodomust est une application monopage réalisée grâce au framework javascript vue.js. Cette interface communique avec le serveur contenant les fonctions d'analyse d'images grâce à des requêtes. Ces requêtes sont envoyées et reçues grâce à une connexion WebSocket. Voici une démo d'une classification multi séquentielle (classification avec plusieurs images) : 
![Démo vidéo de Fodomust](./src/assets/images/documentation/fodomust-web.mp4 "Vidéo demo")

## Etat d'avancement du projet

## Choix techniques du projet

## Commandes nécéssaires à l'installation et au développement du projet 

### Installation des librairies et modules nécessaires au fonctionnement de l'application
```
npm install
```

### Compilation du code et rechargement auto après modification pour le développement
```
npm run serve
```

### Compilation du code pour la production
```
npm run build
```

### Lie et fixe les fichiers
```
npm run lint
```

### Pour customiser la configuration ce référer à la documentation suivante : [Configuration Reference](https://cli.vuejs.org/config/).

