function afficheZoomImg(){

    //Concerne la barre d'outils
    var zoomBtn = document.querySelectorAll(".zoom");
    var dezoomBtn = document.querySelectorAll(".dezoom");
    var imageCarte = document.querySelectorAll(".carte");
    var birdView = document.querySelector(".birdView");
    var brightnessPlusBtn = document.querySelectorAll(".brightnessPlus");
    var brightnessMoinsBtn = document.querySelectorAll(".brightnessMoins");
    var contrastPlusBtn = document.querySelectorAll(".contrastPlus");
    var contrastMoinsBtn = document.querySelectorAll(".contrastMoins");
    var initializeBtn = document.querySelectorAll(".initialize");

    //Création de l'image
    var imageSmall = document.createElement('img');
    var imageSrc = 'data:image/png;base64,' + base64String;
    birdView.appendChild(imageSmall);
    imageSmall.src = imageSrc;

    for(let i = 0; i < divImage.length; i++){

        let image = document.createElement('img');
        image.src = imageSrc;
        divImage[i].appendChild(image);

        //Fonctionnalité de zoom dans l'image
        var zoomScale = 1;
        var brightness = 100;
        var contrast = 100;
        let pos = { top: 0, left: 0, x: 0, y: 0 };

        const mouseDownHandler = function (e) {
            pos = {
                left: divImage[i].scrollLeft,
                top: divImage[i].scrollTop,
                // position actuel du curseur
                x: e.clientX,
                y: e.clientY,
            };

            document.addEventListener('mousemove', mouseMoveHandler);
            document.addEventListener('mouseup', mouseUpHandler);
        };
        const mouseMoveHandler = function (e) {
            // distance entre curseur et déplacement
            const dx = e.clientX - pos.x;
            const dy = e.clientY - pos.y;

            // Scroller divImage vers la nouvelle position
            divImage[i].scrollTop = pos.top - dy;
            divImage[i].scrollLeft = pos.left - dx;
        };

        const mouseUpHandler = function () {
            divImage[i].style.cursor = 'grab';

            document.removeEventListener('mousemove', mouseMoveHandler);
            document.removeEventListener('mouseup', mouseUpHandler);
        };
        divImage[i].addEventListener('mousedown', mouseDownHandler);


        //Ecouteur d'évenements pour les boutons de zoom
        zoomBtn[i].addEventListener('click', function(){
            if(zoomScale < 15){
                zoomScale++;
                //image.style.scale = zoomScale;
                image.style.cssText = "transform : scale("+ zoomScale +"); "
            }
        });
        dezoomBtn[i].addEventListener('click', function(){
            if(zoomScale > 1){
                zoomScale--;
                //image.style.scale = zoomScale;
                image.style.cssText = "transform : scale("+ zoomScale +"); "
            }
        });

        // Ecouteur d'évenements pour les boutons de luminosité
        brightnessPlusBtn[i].addEventListener('click', function(){
            brightness = brightness + 50;
            image.style.filter = `brightness(${brightness}%)`;
        });
        brightnessMoinsBtn[i].addEventListener('click', function(){
            brightness = brightness - 50;
            image.style.filter = `brightness(${brightness}%)`;
        });

        //Ecouteur d'évenements pour les boutons de contraste
        contrastPlusBtn[i].addEventListener('click', function(){
            contrast = contrast + 50;
            image.style.filter = `contrast(${contrast}%)`;
        });
        contrastMoinsBtn[i].addEventListener('click', function(){
            contrast = contrast - 50;
            image.style.filter = `contrast(${contrast}%)`;
        });

        //Tous les filtres sont enlevés de l'image
        initializeBtn[i].addEventListener('click', function(){
            image.style.removeProperty('filter');
            zoomScale = 1;
            //image.style.scale = zoomScale;
            image.style.cssText = "transform : scale("+ zoomScale +"); "
        })
    }
}

export {afficheZoomImg};