import { createRouter, createWebHistory } from 'vue-router'

const routes = [
  {
    path: '/',
    name: 'langue',
    // route level code-splitting
    // this generates a separate chunk (about.[hash].js) for this route
    // which is lazy-loaded when the route is visited.
    component: () => import(/* webpackChunkName: "langue" */ '../views/LangueView.vue')
  },
  {
    path: '/connexion',

    name: 'connexion',
    component: () => import(/* webpackChunkName: "connexion" */ '../views/ConnexionView.vue')
  },
  {
    path: '/didactiel',
    name: 'didactiel',
    component: () => import(/* webpackChunkName: "connexion" */ '../views/DidactielView.vue')
  },
  {
    path: '/openorcreate',
    name: 'openorcreate',
    component: () => import(/* webpackChunkName: "openorcreate" */ '../views/OpenOrCreateView.vue')
  },
  {
    path: '/didactiel',
    name: 'didactiel',
    component: () => import(/* webpackChunkName: "connexion" */ '../views/DidactielView.vue')
  },
  {
    path: '/openproject',
    name: 'openproject',
    component: () => import(/* webpackChunkName: "openproject" */ '../views/OpenProjectView.vue')
  },
  {
    path: '/createproject',
    name: 'createproject',
    component: () => import(/* webpackChunkName: "createproject" */ '../views/CreateProjectView.vue')
  },
  {
    path: '/projectsolo',
    name: 'projectsolo',
    component: () => import(/* webpackChunkName: "projectsolo" */ '../views/ProjectSolo.vue')
  },
  {
    path: '/projectduo',
    name: 'projectduo',
    component: () => import(/* webpackChunkName: "projectduo" */ '../views/ProjectDuo.vue')
  },
  {
    path: '/imagesSelected',
    name: 'imagesSelected',
    component: () => import(/* webpackChunkName: "generatedata" */ '../views/imagesSelected.vue')
  },

  {
    path: '/generatedata',
    name: 'generatedata',
    component: () => import(/* webpackChunkName: "generatedata" */ '../views/GenerateDataView.vue')
  },
  {
    path: '/datapanel',
    name: 'datapanel',
    component: () => import(/* webpackChunkName: "datapanel" */ '../views/DataPanelView.vue')
  },
  {
    path: '/classification',
    name: 'classification',
    component: () => import(/* webpackChunkName: "classification" */ '../views/ClassificationView.vue')
  },
  {
    path: '/results-image',
    name: 'results-image',
    component: () => import(/* webpackChunkName: "results-image" */ '../views/ResultsImageView.vue')
  },
  {
    path: '/results-cardinality',
    name: 'results-cardinality',
    component: () => import(/* webpackChunkName: "results-cardinality" */ '../views/ResultsCardinalityView.vue')
  },
  {
    path: '/results-centroids',
    name: 'results-centroids',
    component: () => import(/* webpackChunkName: "results-centroids" */ '../views/ResultsCentroidsView.vue')
  },
  {
    path: '/results-evaluation',
    name: 'results-evaluation',
    component: () => import(/* webpackChunkName: "results-evaluation" */ '../views/ResultsEvaluationView.vue')
  },
  {
    path: '/results-historique',
    name: 'results-historique',
    component: () => import(/* webpackChunkName: "results-historique" */ '../views/ResultsHistoriqueView.vue')
  },
  {
    path: '/results-projection-panel',
    name: 'results-projection-panel',
    component: () => import(/* webpackChunkName: "results-projection-panel" */ '../views/ResultsProjectionPanelView.vue')
  },
  {
    path: '/results-scatter-plot',
    name: 'results-scatter-plot',
    component: () => import(/* webpackChunkName: "results-scatter-plot" */ '../views/ResultsScatterPlotView.vue')
  },
  {
    path: '/results-similarity',
    name: 'results-similarity',
    component: () => import(/* webpackChunkName: "results-similarity" */ '../views/ResultsSimilarityView.vue')
  },
  {
    path: '/results-weights',
    name: 'results-weights',
    component: () => import(/* webpackChunkName: "results-weights" */ '../views/ResultsWeightsView.vue')
  },
  {
    path: '/results-time-series',
    name: 'results-time-series',
    component: () => import(/* webpackChunkName: "results-weights" */ '../views/ResultsTimeSeries.vue')
  }
]

const router = createRouter({
  history: createWebHistory(process.env.BASE_URL),
  routes
})

export default router
