import { createStore } from 'vuex'
import protobuf from 'protobufjs'
import {toRaw} from 'vue'
import {base64String} from "../../public/javascript/base64"
// import CryptoJS from 'crypto-js'
// import SparkMD5 from 'spark-md5'
// import {base64} from "../../public/javascript/bundle";

const moduleA = {
    state: {
        choixLangue : "fr",
        ws: {},
        Req: {},
        Resp: {},
        msg: {},
        message: {},
        uid : "",
        request : {},
        result : "",
        result2 : [],
        getImg : '',
        second : false,
        currentClassifID : "",
        currentHandler : null,
        file : {},
        files : [],
        isMulti : false,
        loadImage_ctx :  {
            imageSession : {},
            imageToLoad : [],
            name : "",
            currentImage : {},
            loadedImage : "",
            hashedFile : "",
            base64 : "",
            dataName : "",
            imgId : "",
            imgIds : [],
            samplingMethod : "",
            idPercentage : "",
            paramSamplingMethod : ""
        },
        dataInterface : {
          attributeName : []
        },
        classification : {
            clusterName : [],
            methodName : "",
            classifParam : [],
            weightsParam: []
        },
         classificationResult : {
            colors : [],
            cardinality : [],
             height : null,
             width : null,
             clusterMap: [],
             rgbaColors : [],
             centroideValue : []
         },
        clusters: []
    },
    getters: {
        getWS(state){
            return state.ws
        },
        getChoix(state){
            return state.choixLangue
        },
        getFiles(state){
            return state.loadImage_ctx.imageToLoad
        },
        getHashFile(state){
            return state.loadImage_ctx.hashedFile
        },
        getRequest(state){
            return toRaw(state.request)
        },
        getResult(state){
            return state.result
        },
        getCurrentHandler(state){
            return state.currentHandler
        },
        getBase64(state){
            return state.loadImage_ctx.base64
        },
        getLoadedImg(state){
            return state.loadImage_ctx.loadedImage
        },
        getName(state){
            return state.loadImage_ctx.name
        },
        getDataName(state){
            return state.loadImage_ctx.dataName
        },
        getImgId(state){
            return state.loadImage_ctx.imgId
        },
        getClusterName(state){
            return state.classification.clusterName
        },
        getResultColors(state){
            return state.classificationResult.colors
        },
        getResultCardinality(state){
            return state.classificationResult.cardinality
        },
        getTabCluster(state){
            return state.clusters
        },
        getHeight(state){
            return state.classificationResult.height
        },
        getWidth(state){
            return state.classificationResult.width
        },
        getClusterMap(state){
            return state.classificationResult.clusterMap
        },
        getClusterColorsRGBA(state){
            return state.classificationResult.rgbaColors
        },
        getCentroideValue(state){
            return state.classificationResult.centroideValue
        },
        getAttributeNames(state) {
            return state.dataInterface.attributeName
        },
        getImgIDS(state){
            return state.loadImage_ctx.imgIds
        },
        getFile(state){
            return state.file;
        },

        getFilesJad(state){
            return state.files;
        },
        getIsMulti(state){
            return state.isMulti;
        }

    },
    mutations: {
        setIsMulti(state, valeur){
            state.isMulti = valeur
        },
        setLoadedImg(state, valeur){
            state.loadImage_ctx.loadedImage = valeur
        },
        setNameImage(state, valeur) {
            state.loadImage_ctx.name = valeur
        },
        setColors(state, valeur){
          state.classificationResult.colors.push(valeur)
        },
        setCardinality(state, valeur){
          state.classificationResult.cardinality.push(valeur)
        },
        setTabCluster(state, valeur){
            state.clusters.push(valeur)
        },
        setClusterMap(state, valeur){
            state.classificationResult.clusterMap = valeur
        },
        setClusterColors(state, valeur){
          state.classificationResult.rgbaColors.push(valeur)
        },
        setFile(state, valeur){
            state.file = valeur
        },
        setFilesJad(state, valeur){
            state.files.push(valeur)
        },
        getImgId(state,valeur){
            state.loadImage_ctx.imgId = valeur
        },
        setCentroideValue(state, valeur){
          state.classificationResult.centroideValue.push(valeur)
        },
        setAttributeName(state, valeur){
          state.dataInterface.attributeName.push(valeur)
        },
        setImgIDS(state, valeur){
            state.loadImage_ctx.imgIds.push(valeur)
        },
        rootReq(state, root) {
            state.Req = toRaw(root.lookupType("FoDoMustProto.RequestMessage"));
        },
        rootResp(state, root) {
            state.Resp = root.lookupType("FoDoMustProto.ResponseMessage");
        },
        updateRawMessageBuffer(state, message) {
            state.msg = toRaw(message);
        },
        requestClientId(state) {
                // state.ws.send(toRaw(state.Req).encode(toRaw(state.Req).create(toRaw(state.msg))).finish())
                state.request = toRaw({header: 14})
        },
        setUID(state, valeur){
            if(!state.uid){
                state.uid = valeur
            }
        },
        setCurrentHandler(state, valeur){
            state.currentHandler = valeur
        },
        setFiles(state, valeur){
              for(let i = 0; i < valeur.length; i++){
                  toRaw(state.loadImage_ctx.imageToLoad)[i] = valeur[i]
              }
        },
        setResult (state, payload){
            state.result = payload
        },
        setResult2(state, valeur){
            state.result2.push(valeur)
        },
        setDataName(state, valeur){
            state.loadImage_ctx.dataName = valeur
        },
        setImageId(state, valeur){
            state.loadImage_ctx.imgId = valeur
        },
        setSamplingMethod(state, valeur){
          state.loadImage_ctx.samplingMethod = valeur
        },
        setIdPercentage(state, valeur){
          state.loadImage_ctx.idPercentage = valeur
        },
        setParamSamplingMethod(state, valeur){
            state.loadImage_ctx.paramSamplingMethod = valeur
        },
        setCurrentClassifID(state, valeur){
          state.currentClassifID = valeur
        },
        setClusterName(state, valeur){
            state.classification.clusterName.push(valeur)
        },
        setMethod(state, valeur){
            state.classification.methodName = valeur
        },
        setClassifParam(state, valeur){
          state.classification.classifParam.push(valeur)
        },
        setWeightsParam(state, valeur){
          state.classification.weightsParam.push(valeur)
        },
        setHeight(state, valeur){
            state.classificationResult.height = valeur
        },
        setWidth(state, valeur){
            state.classificationResult.width = valeur
        },
        requestOpenImage(state){
            state.request = toRaw({
                imageOpenRequest:{
                    base64File: state.msg.base64,
                    checksum: state.msg.Checksum,
                    isLaunchOrthoRect: false,
                    fileName: state.msg.FileName,
                    overWrite: state.msg.OverWrite
                },
                clientId: state.uid,
                header: 20

            })
        },
        requestGetImageInterface(state){
             state.request = toRaw({
                 imageInterfaceRequest: {
                     idMessage : state.result.toString()
                 },
                 clientId : state.uid,
                 header : 21
            });
            // let start = Date.now();
            // -> switch sur le message.status
            //header 20 ou 21, en fonction du status
        },
        requestBufferImage(state){
            // console.log( Date.now() - start);
            // state.result2.push(/*message*/event.imageInterfaceResp.imageInterf);
            state.request = toRaw({
                bufferedImageRequest:{
                    idImage: state.result,
                    // idImage: state.loadImage_ctx.imgIds,
                    // idImage: 2,
                    doRescale: false
                },
                clientId: state.uid,
                header: 22
            });
        },
        requestCreateDataImage(state){
            if (!state.second) {
                state.request =
                    toRaw({
                        dataImageRequest:{
                            // images: toRaw(state.loadImage_ctx.imgIds),
                            images :
                                toRaw(state.loadImage_ctx.imgIds),
                            samplingMethod: Number(state.loadImage_ctx.samplingMethod), //2 ==> Par intervale; 1 ==> Random
                            idPercentage: state.loadImage_ctx.idPercentage, //0 ==> ByPercentage, 1 ==> By count
                            paramSamplingMethode: parseFloat(state.loadImage_ctx.paramSamplingMethod), //Si c'est par pourcentag, sa valeur est le pourcentage, sinon, c'est le nombre de pixel
                            nameData: state.loadImage_ctx.dataName, // Défini par le user
                        },
                        clientId: state.uid,
                        header: 23
                    })
            }
            else
                /*MONO_STRATEGY_APPROACH 			= 1;
                MULTI_STRATEGY_APPROACH 		= 2;
                MULTI_STRATEGY_ETC_APPROACH 	= 3;
                MACLAW_APPROACH 				= 4;
                VOTING_APPROACH 				= 5;
                MULTIRESOLUTION_APPROACH 		= 6;
                IMPORT_APPROACH 				= 7; */
                state.request = toRaw({
                    rootClassificationRequest:{
                        idClassif: 1
                    },
                    clientId: state.uid,
                    header: 18
                });
        },
        requestDataInterface(state) {
            state.request = toRaw({
                dataInterfaceRequest:{
                    id: state.result
                },
                clientId: state.uid,
                header: 1
            });
        },
        requestCreateClassification(state){
            state.request = toRaw({
                classificationRequest:{
                    idData: state.result,
                    classification: {
                        isHybrid: false,
                        isMaclaw: false,
                        idData: state.result,
                        choiceApproch: 1,
                        distanceUse: 1,
                        type: "utils.ParamClassifSimple",
                        selectedMethod: String(state.classification.methodName),
                        paramClustering: toRaw(state.classification.classifParam),
                        weightsParam: toRaw(state.classification.weightsParam),
                        hClustering: false
                    }
                },
                clientId: state.uid,
                header: 2
            });
        },
        requestGetFinish(state) {
            state.currentClassifID = 1
            state.request = toRaw({
                finishRequest:{
                    idClassif: String(state.currentClassifID)
                },
                clientId: state.uid,
                header: 15
            });
        },
        //If : if finishResp.finish!='100'
        requestGetFinish2(state){
            state.request = toRaw({
                resultClassificationRequest:{
                    idClassif: String(state.currentClassifID)
                },
                clientId: state.uid,
                header: 9
                }
            )
        },
        requestGetMatrice(state){
            state.request = toRaw({
                    MatriceDistanceRequest: {
                        idClassification: Number(state.currentClassifID),
                        type: "1",
                        nbObject: 5
                    },
                    clientId: state.uid,
                    header: 17
                }
            )
        },
        // requestGetScaling(state){
        //   state.request = toRaw(
        //       {
        //           scalingRequest
        //       }
        //   )
        // },
        msgDecode(state, event) {
            state.Resp.decode(new Uint8Array(event.data), event.data.length);
        },
        setChecksum(state, valeur){
            state.loadImage_ctx.hashedFile = valeur
        }
    },
    actions: {
        initConnection(context) {

            // eslint-disable-next-line no-unused-vars
            const root = protobuf.load("protobuf/Messages.proto").catch((err) => {
                console.log(err);
            }).then((root) => {
                context.commit('rootReq', root);
                context.commit('rootResp', root);
                console.log("After load");
            }).then(() => {
                context.state.ws = new WebSocket("ws://127.0.0.1:8081");
                context.state.ws.binaryType = "arraybuffer";
                context.state.ws.onmessage = function (event) {
                    console.log('event.data',event.data)
                    let msg = context.state.Resp.decode(new Uint8Array(event.data), event.data.length)
                    console.log('message:', msg)
                    context.state.currentHandler(msg);
                }
                context.state.ws.onopen = function () {
                    context.dispatch('sendMessage', 'requestClientId');
                }
            })


        },
        sendMessage(context, messagePreparateur) {
            console.log(messagePreparateur)
            //Message
            if (messagePreparateur!=null) {
                context.commit(messagePreparateur)
            }

            // context.commit('requestOpenImage')
            let objectReq = toRaw(context.state.request);

            console.log('requete :', objectReq);

            //Conversion au format protobuf
            // context.commit('msgDecode', objectReq)

            //Envoi du message
            let sendReq = context.state.Req.encode(context.state.Req.create(objectReq)).finish()
            context.state.ws.send(sendReq);
        },
        loadImage(context, file, withPayload, overwrite) {
            //Pour convertir en md5, j'ai utilisé la librairie crypto-js
            //c'est que dans certains cas mais convertion en base64 du fichier après verif du checksum
            let base64Var;
            context.dispatch('calculateFile', file[0]).then(() => {
                console.log(context.state.loadImage_ctx.hashedFile)

            }).then(() => {
                //Si cette condition est vraie, alors il faut procéder à l'encodage en b64 optionnellement
                if (withPayload === false) {
                    //Cas où hash est défini mais base64String = null
                    console.log('cas 5 : IMAGE_DUPLICATED')
                    base64Var = "";
                    overwrite = false;
                } else {
                    //Cas où le hash est défini est base64String l'est aussi
                    console.log('cas 4 : TO_UP_LOAD')
                    // base64 = context.dispatch('calculateBase64', file)
                    base64Var = base64String;
                    overwrite = false;
                    console.log(base64Var, overwrite)

                }
            })
        },
        calculateBase64(context, file) {
            let reader = new FileReader();
            reader.readAsDataURL(file);
            reader.onload = function () {
                console.log(reader.result);
            };
            reader.onerror = function (error) {
                console.log('Error: ', error);
            };
            reader.onloadend = function(){
                context.state.loadImage_ctx.base64 = reader.result;
                console.log(reader.result)
            }
        }
        // ,
        // calculateMD5(context,file){
        //     //Save the result of hash in the vuex store
        //     context.state.loadImage_ctx.hashedFile = CryptoJS.MD5(toRaw(file[0])).toString()
        //     console.log('*****************************************cryptoMD5',CryptoJS.MD5(toRaw(file[0])).toString())
        // }
    }
};



export default createStore({
    modules: {
        a: moduleA
    }
})